VERSION 5.00
Begin VB.Form frmPopup 
   BorderStyle     =   4  'Fixed ToolWindow
   ClientHeight    =   2130
   ClientLeft      =   3540
   ClientTop       =   1680
   ClientWidth     =   2010
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2130
   ScaleWidth      =   2010
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   345
      Left            =   570
      TabIndex        =   4
      Top             =   1680
      Width           =   915
   End
   Begin VB.CommandButton cmdContinue 
      Caption         =   "&Continue"
      Height          =   345
      Left            =   1020
      TabIndex        =   3
      Top             =   810
      Width           =   915
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "&Pause"
      Height          =   345
      Left            =   1020
      TabIndex        =   2
      Top             =   420
      Width           =   915
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "S&top"
      Height          =   345
      Left            =   60
      TabIndex        =   1
      Top             =   810
      Width           =   915
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "&Start"
      Height          =   345
      Left            =   60
      TabIndex        =   0
      Top             =   420
      Width           =   915
   End
   Begin VB.Label lblStartAcct 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   90
      TabIndex        =   6
      Top             =   1290
      Width           =   1845
   End
   Begin VB.Label lblStartType 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   60
      TabIndex        =   5
      Top             =   60
      Width           =   1845
   End
End
Attribute VB_Name = "frmPopup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_xLocation           As Single
Private m_yLocation           As Single

Private mlngCurrentState      As Long
Private mlngCtrlAccepted      As Long
Private mlngStartType         As Long
Private mstrLogonAcct         As String

Public Sub Location(x As Single, y As Single)
   m_xLocation = x * Screen.TwipsPerPixelX
   m_yLocation = y * Screen.TwipsPerPixelY
End Sub

Public Sub ServiceStatus(xlngCurrentState As Long, _
                         xlngCtrlAccepted As Long, _
                         xlngStartType As Long, _
                         xstrLogonAcct As String)
   
   mlngCurrentState = xlngCurrentState
   mlngCtrlAccepted = xlngCtrlAccepted
   mlngStartType = xlngStartType
   mstrLogonAcct = xstrLogonAcct
   SetControls
   
End Sub

Private Sub cmdContinue_Click()
   Me.Visible = False
   frmMySCM.DoMsg enumControlCodes.SERVICE_CONTROL_CONTINUE
   Unload Me
End Sub

Private Sub cmdPause_Click()
   Me.Visible = False
   frmMySCM.DoMsg enumControlCodes.SERVICE_CONTROL_PAUSE
   Unload Me
End Sub

Private Sub cmdStart_Click()
   Me.Visible = False
   frmMySCM.DoMsg enumControlCodes.SERVICE_CONTROL_START
   Unload Me
End Sub

Private Sub cmdStop_Click()
   Me.Visible = False
   frmMySCM.DoMsg enumControlCodes.SERVICE_CONTROL_STOP
   Unload Me
End Sub

Private Sub cmdExit_Click()
   Unload Me
End Sub

Private Sub Form_Load()
   
   Me.Left = m_xLocation + 600
   Me.Top = m_yLocation - (Me.Height / 2)

End Sub

Private Sub SetControls()
   Dim pblnCanStop      As Boolean
   Dim pblnCanPause     As Boolean
   Dim pblnCancelSub    As Boolean
   
   Me.lblStartAcct = mstrLogonAcct
   
   Select Case mlngStartType
      Case enumServiceStart.SERVICE_AUTO_START
         ' Do nothing, just fall thru to checks below
         Me.lblStartType.Caption = "Automatic Start"
         pblnCancelSub = False
      Case enumServiceStart.SERVICE_DEMAND_START
         ' Do nothing, just fall thru to checks below
         Me.lblStartType.Caption = "Manual Start"
         pblnCancelSub = False
      Case enumServiceStart.SERVICE_DISABLED
         Me.lblStartType.Caption = "Disabled"
         pblnCancelSub = True
      Case enumServiceStart.SERVICE_BOOT_START
         Me.lblStartType.Caption = "Boot Start"
         pblnCancelSub = True
      Case enumServiceStart.SERVICE_SYSTEM_START
         Me.lblStartType.Caption = "System Start"
         pblnCancelSub = True
      Case Else
         Me.lblStartType.Caption = "Unknown"
         pblnCancelSub = True
   End Select
   
   If pblnCancelSub = True Then
      cmdStart.Enabled = False
      cmdStop.Enabled = False
      cmdContinue.Enabled = False
      cmdPause.Enabled = False
      Exit Sub
   End If
   
   ' See if it accepts pause/continue
   If mlngCtrlAccepted And enumControlsAccepted.SERVICE_ACCEPT_PAUSE_CONTINUE Then
      pblnCanPause = True
   Else
      pblnCanPause = False
   End If
   
   ' See if you can stop it
   If mlngCtrlAccepted And enumControlsAccepted.SERVICE_ACCEPT_STOP Then
      pblnCanStop = True
   Else
      pblnCanStop = False
   End If
   
   Select Case mlngCurrentState
      Case enumCurrentState.SERVICE_STOPPED
         cmdStop.Enabled = False
         cmdContinue.Enabled = False
         cmdPause.Enabled = False
         cmdStart.Enabled = True
      
      Case enumCurrentState.SERVICE_RUNNING
         cmdStart.Enabled = False
         cmdContinue.Enabled = False
         
         If pblnCanStop = True Then
            cmdStop.Enabled = True
         Else
            cmdStop.Enabled = False
         End If
         
         If pblnCanPause = True Then
            cmdPause.Enabled = True
         Else
            cmdPause.Enabled = False
         End If
         
      Case enumCurrentState.SERVICE_PAUSED
         cmdStart.Enabled = False
         cmdPause.Enabled = False
      
         cmdStop.Enabled = True
         cmdContinue.Enabled = True
      
      Case enumCurrentState.SERVICE_STOP_PENDING
         cmdStart.Enabled = False
         cmdStop.Enabled = False
         cmdContinue.Enabled = False
         cmdPause.Enabled = False
      
      Case enumCurrentState.SERVICE_START_PENDING
         cmdStart.Enabled = False
         cmdStop.Enabled = False
         cmdContinue.Enabled = False
         cmdPause.Enabled = False
      
      Case enumCurrentState.SERVICE_PAUSE_PENDING
         cmdStart.Enabled = False
         cmdStop.Enabled = False
         cmdContinue.Enabled = False
         cmdPause.Enabled = False
      
      Case enumCurrentState.SERVICE_CONTINUE_PENDING
         cmdStart.Enabled = False
         cmdStop.Enabled = False
         cmdContinue.Enabled = False
         cmdPause.Enabled = False
      
      Case Else
         cmdStart.Enabled = False
         cmdStop.Enabled = False
         cmdContinue.Enabled = False
         cmdPause.Enabled = False
   
   End Select
    
End Sub
